Option Explicit On 
Option Strict On
Option Compare Binary

Imports Microsoft.VisualBasic
Imports System.Windows.Forms

' <remarks>
'   Hauptformular der Anwendung.
' </remarks>
Public Class MainForm
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "
    Public Sub New()
        MyBase.New()
        InitializeComponent()
        Me.lblStatistics.Text = ""
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Friend WithEvents lblStatistics As System.Windows.Forms.Label
    Friend WithEvents txtCurrentFont As System.Windows.Forms.TextBox
    Friend WithEvents btnLoadFonts As System.Windows.Forms.Button
    Friend WithEvents FontListBox1 As FontList.FontListBox
    Friend WithEvents lblSelectedFontName As System.Windows.Forms.Label

    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        Me.btnLoadFonts = New System.Windows.Forms.Button()
        Me.lblStatistics = New System.Windows.Forms.Label()
        Me.txtCurrentFont = New System.Windows.Forms.TextBox()
        Me.FontListBox1 = New FontList.FontListBox()
        Me.lblSelectedFontName = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'btnLoadFonts
        '
        Me.btnLoadFonts.Anchor = System.Windows.Forms.AnchorStyles.Bottom
        Me.btnLoadFonts.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.btnLoadFonts.Location = New System.Drawing.Point(112, 328)
        Me.btnLoadFonts.Name = "btnLoadFonts"
        Me.btnLoadFonts.Size = New System.Drawing.Size(88, 24)
        Me.btnLoadFonts.TabIndex = 4
        Me.btnLoadFonts.Text = "&Neu laden"
        '
        'lblStatistics
        '
        Me.lblStatistics.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.lblStatistics.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.lblStatistics.Location = New System.Drawing.Point(16, 272)
        Me.lblStatistics.Name = "lblStatistics"
        Me.lblStatistics.Size = New System.Drawing.Size(96, 48)
        Me.lblStatistics.TabIndex = 3
        Me.lblStatistics.Text = "#"
        Me.lblStatistics.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'txtCurrentFont
        '
        Me.txtCurrentFont.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtCurrentFont.Location = New System.Drawing.Point(16, 16)
        Me.txtCurrentFont.Name = "txtCurrentFont"
        Me.txtCurrentFont.Size = New System.Drawing.Size(280, 21)
        Me.txtCurrentFont.TabIndex = 0
        Me.txtCurrentFont.Text = ""
        '
        'FontListBox1
        '
        Me.FontListBox1.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.FontListBox1.DrawMode = System.Windows.Forms.DrawMode.OwnerDrawVariable
        Me.FontListBox1.FontSize = 8.25!
        Me.FontListBox1.Location = New System.Drawing.Point(16, 40)
        Me.FontListBox1.Name = "FontListBox1"
        Me.FontListBox1.Size = New System.Drawing.Size(280, 200)
        Me.FontListBox1.TabIndex = 1
        '
        'lblSelectedFontName
        '
        Me.lblSelectedFontName.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.lblSelectedFontName.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.lblSelectedFontName.Location = New System.Drawing.Point(16, 248)
        Me.lblSelectedFontName.Name = "lblSelectedFontName"
        Me.lblSelectedFontName.Size = New System.Drawing.Size(280, 24)
        Me.lblSelectedFontName.TabIndex = 2
        Me.lblSelectedFontName.Text = "#"
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 14)
        Me.ClientSize = New System.Drawing.Size(312, 366)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lblSelectedFontName, Me.FontListBox1, Me.txtCurrentFont, Me.lblStatistics, Me.btnLoadFonts})
        Me.Font = New System.Drawing.Font("Tahoma", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.MinimumSize = New System.Drawing.Size(320, 400)
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "FontList"
        Me.ResumeLayout(False)

    End Sub
#End Region

    Private Sub btnLoadFonts_Click( _
      ByVal sender As System.Object, _
      ByVal e As System.EventArgs) _
      Handles btnLoadFonts.Click

        ' "Neu Laden".
        If Me.btnLoadFonts.Text = "&Neu laden" Then
            Me.lblStatistics.Text = ""
            Me.btnLoadFonts.Text = "&Stoppen"
            Me.FontListBox1.Refill()

        ' "Stoppen".
        Else
            If Me.FontListBox1.Enumerating Then
                Me.FontListBox1.AbortEnumeration()
            Else
                MessageBox.Show("Die Enumeration luft nicht " & _
                  "und kann nicht abgebrochen werden!", _
                  Application.ProductName, _
                  MessageBoxButtons.OK, _
                  MessageBoxIcon.Exclamation)
            End If
            Me.btnLoadFonts.Text = "&Neu laden"
        End If
    End Sub

    Private Sub MainForm_Closed( _
      ByVal sender As Object, _
      ByVal e As System.EventArgs) Handles MyBase.Closed

        ' Wenn noch enumeriert wird, dann den
        ' Enumerationsvorgang abbrechen.
        If Me.FontListBox1.Enumerating Then
            Me.FontListBox1.AbortEnumeration()
        End If
    End Sub

    Private Sub txtCurrentFont_TextChanged( _
      ByVal sender As System.Object, _
      ByVal e As System.EventArgs) _
      Handles txtCurrentFont.TextChanged
        Me.FontListBox1.SelectedIndex = _
          Me.FontListBox1.FindString(Me.txtCurrentFont.Text)
    End Sub

    Private Sub FontListBox1_SelectedIndexChanged( _
      ByVal sender As System.Object, _
      ByVal e As System.EventArgs) _
      Handles FontListBox1.SelectedIndexChanged
        If Me.FontListBox1.SelectedItem Is Nothing Then
            Me.lblSelectedFontName.Text = "(keine Auswahl)"
        Else
            Me.lblSelectedFontName.Text = _
              Me.FontListBox1.SelectedItem.ToString()
        End If
    End Sub

    Private Sub FontListBox1_EnumerationFinished( _
      ByVal sender As Object, _
      ByVal e As FontList.EnumerationFinishedEventArgs) _
      Handles FontListBox1.EnumerationFinished
        Me.lblStatistics.Text = _
            "Gltig: " & e.ValidFontsCount.ToString() & _
            ControlChars.NewLine & _
            "Ungltig: " & e.InvalidFontsCount.ToString() & _
            ControlChars.NewLine & _
            "Abgebrochen: " & e.Cancelled.ToString()
        Me.btnLoadFonts.Text = "&Neu laden"
    End Sub
End Class